"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const cli_1 = require("@graphql-codegen/cli");
const PluginTypescript = __importStar(require("@graphql-codegen/typescript"));
const PluginTypescriptOperations = __importStar(require("@graphql-codegen/typescript-operations"));
const PluginSchemaAst = __importStar(require("@graphql-codegen/schema-ast"));
const typescriptConfig = {
    exportFragmentSpreadSubTypes: true,
    preResolveTypes: true,
    skipTypeNameForRoot: true,
};
function pluginLoader(name) {
    if (name === '@graphql-codegen/typescript') {
        return Promise.resolve(PluginTypescript);
    }
    else if (name === '@graphql-codegen/typescript-operations') {
        return Promise.resolve(PluginTypescriptOperations);
    }
    else {
        return Promise.resolve(PluginSchemaAst);
    }
}
function default_1(graphqlServer, options) {
    const schemaPath = path_1.default.resolve(options.schemaOutputPath, 'schema.graphql');
    function generateSchema() {
        return cli_1.generate({
            schema: {
                [graphqlServer]: options.schemaOptions,
            },
            pluginLoader,
            generates: {
                [schemaPath]: {
                    plugins: [{ 'schema-ast': typescriptConfig }],
                    config: typescriptConfig,
                },
                [path_1.default.resolve(options.typesOutputPath, 'graphql-schema.d.ts')]: {
                    plugins: [{ typescript: typescriptConfig }],
                    config: typescriptConfig,
                },
            },
        }, true);
    }
    function generateTypes() {
        const config = Object.assign(Object.assign({}, typescriptConfig), { onlyOperationTypes: true });
        return cli_1.generate({
            schema: schemaPath,
            pluginLoader,
            documents: path_1.default.resolve(options.resolvedQueriesPath, './*.graphql'),
            generates: {
                [path_1.default.resolve(options.typesOutputPath, 'graphql-operations.d.ts')]: {
                    plugins: ['typescript', { 'typescript-operations': config }],
                    config,
                },
            },
        }, true);
    }
    return { generateSchema, generateTypes };
}
exports.default = default_1;
